#include "tc_p_zDepth.h"


DLLEXPORT int tc_p_zDepth_version(void) {return(2);}

DLLEXPORT miBoolean tc_p_zDepth(miColor *result, miState *state, depth_t *paras)
{
	if(state->type == miRAY_SHADOW || state->type == miRAY_DISPLACE)
		return miFALSE;

	miScalar *near;
	miScalar *far;
	miBoolean *pfloat, ok;
	miColor *transp;
	miScalar depth, depthHere, depthReflect;
	miBoolean *pinvert, *mirrorM, *split, *reflect;
        miScalar pDepth;
        miVector parentDir;


	near = mi_eval_scalar(&paras->tnear);
	far = mi_eval_scalar(&paras->tfar);
	pfloat = mi_eval_boolean(&paras->use_float);
	pinvert = mi_eval_boolean(&paras->invert);
	transp = mi_eval_color(&paras->transparency);
        mirrorM = mi_eval_boolean(&paras->mirrorMode);
        split = mi_eval_boolean(&paras->split);
        reflect = mi_eval_boolean(&paras->reflect);
        
        
        if(*reflect == miTRUE) {
            *split = miTRUE;
        }
        

        depth = (miScalar)state->dist;
        depthHere = 0;
        depthReflect = 0;

	miScalar aver = 1;

	if(*pfloat == miFALSE)
		aver = *far - *near;
        
	switch(state->type)
	{
            
		case miRAY_EYE:
			if(depth < *near)
				depth = *near;
			if(depth > *far)
				depth = *far;
			depth = (depth - *near)/aver;
                        depthHere = depth;
                    break;
                    
        case miRAY_REFLECT:
            if (*mirrorM == miTRUE) {
                // calculate the actual distance from the camera of the object were
                // reflecting to based on the triangle created between the eye ray and reflected ray.
                pDepth = state->parent->dist;
                parentDir = state->parent->dir;
                mi_vector_mul(&parentDir, -1);
                depth = sqrt(depth * depth + pDepth * pDepth - 2 * depth * pDepth * ( mi_vector_dot(&parentDir, &state->dir) / ( mi_vector_norm(&parentDir) * mi_vector_norm(&state->dir) )));
            } else {
                // just sum the distances
                switch (state->reflection_level) {
                    case 1:
                        depth = depth + state->parent->dist;
                        break;
                    case 2:
                        depth = depth + state->parent->dist + state->parent->parent->dist;
                        break;
                    case 3:
                        depth = depth + state->parent->dist + state->parent->parent->dist + state->parent->parent->parent->dist;
                        break;
                    case 4:
                        depth = depth + state->parent->dist + state->parent->parent->dist + state->parent->parent->parent->dist + state->parent->parent->parent->parent->dist;
                        break;
                    case 5:
                        depth = depth + state->parent->dist + state->parent->parent->dist + state->parent->parent->parent->dist + state->parent->parent->parent->parent->dist + state->parent->parent->parent->parent->parent->dist;
                        break;
                }
            }
            
            if(depth < *near)
                depth = *near;
            if(depth > *far)
                depth = *far;
			depth = (depth - *near)/aver;
            break;
                    
        case miRAY_TRANSPARENT:
                if(depth > *far)
                        depth = *far;
                depth = depth / aver;
                break;
	}

	result->a = 0;

	if(transp->a < 1)
	{
		result->a = transp->a;
		miColor transp_res;
		mi_trace_transparent(&transp_res, state);
		depth += transp_res.r * (1-transp->a);
		result->a += transp_res.a;
	}
	else
            result->a = 1;
    
        
        if (*reflect == miTRUE) {
            miVector	dir;
            miScalar    save_ior;
            miColor reflect_res;
            save_ior   = state->ior;
            state->ior = state->ior_in;
            
            mi_reflection_dir(&dir, state);
            ok = miFALSE;
            if (state->reflection_level < state->options->reflection_depth &&
                state->reflection_level + state->refraction_level <
                state->options->trace_depth)
                ok = mi_trace_reflection(&reflect_res, state, &dir);
            
            if (!ok) {
                miTag savevol = state->volume;
                state->volume = 0;
                ok = mi_trace_environment(&reflect_res, state, &dir);
                state->volume = savevol;
            }
            
            depthReflect = reflect_res.r;
            state->ior = save_ior;
        }
        
        
    if(*pinvert == miTRUE) {
        
        if(*pfloat == miFALSE) {
			depth = 1 -depth;
                        depthHere = 1 - depthHere;
        } else {
			depth = (*far - *near) -depth;
                        depthHere = (*far - *near) -depthHere;
	}
    }

    if(*split == miTRUE && state->type == miRAY_EYE) { 
        result->r = depthHere;
        result->g = depth;
        result->b = depthReflect;
    } else {
	result->r = result->g = result->b = depth;
	return(miTRUE);
    }
}